﻿using Microsoft.AspNetCore.Builder;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace MiddlewareWithParameters
{
    public static class MiddlewareExtensions
    {
        public static IApplicationBuilder UseGreetingMiddleware(this IApplicationBuilder app, GreetingOptions options)
        {
            return app.UseMiddleware<GreetingMiddleware>(options);
        }

        public static IApplicationBuilder UseGreetingMiddlewareAction(this IApplicationBuilder app, Action<GreetingOptions> optionsAction)
        {
            var options = new GreetingOptions();
            optionsAction(options);

            return app.UseMiddleware<GreetingMiddleware>(options);
        }
    }
}
