﻿using Microsoft.Extensions.DependencyInjection;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace MiddlewareWithParameters
{
    public static class ServiceExtensions
    {
        public static IServiceCollection AddMessageService(this IServiceCollection services, GreetingOptions options)
        {
            return services.AddScoped<IMessageService>(factory => new MessageService(options));
        }

        public static IServiceCollection AddMessageServiceAction(this IServiceCollection services, Action<GreetingOptions> optionsAction)
        {
            var options = new GreetingOptions();
            optionsAction(options);

            return services.AddScoped<IMessageService>(factory => new MessageService(options));
        }
    }
}
