﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.DependencyInjection;

namespace MiddlewareWithParameters
{
    public class Startup
    {
        // This method gets called by the runtime. Use this method to add services to the container.
        // For more information on how to configure your application, visit https://go.microsoft.com/fwlink/?LinkID=398940
        public void ConfigureServices(IServiceCollection services)
        {
            services.AddMessageService(new GreetingOptions
            {
                GreetAt = "Morning",
                GreetTo = "Tahir"
            });

            services.AddMessageServiceAction(options =>
            {
                options.GreetAt = "Morning";
                options.GreetTo = "Tahir";
            });
        }

        public void Configure(IApplicationBuilder app, IHostingEnvironment env, IMessageService msg)
        {
            app.Run(async (context) =>
            {
                await context.Response.WriteAsync(msg.FormatMessage("by sanshi"));
            });
        }

        //// This method gets called by the runtime. Use this method to configure the HTTP request pipeline.
        //public void Configure(IApplicationBuilder app, IHostingEnvironment env)
        //{
        //    //app.UseGreetingMiddleware(new GreetingOptions {
        //    //    GreetAt = "Morning",
        //    //    GreetTo = "Tahir"
        //    //});

        //    app.UseGreetingMiddlewareAction(options =>
        //    {
        //        options.GreetAt = "Morning";
        //        options.GreetTo = "Tahir";
        //    });
        //}

    }
}
